<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <gz-data-table
      ref="gzdatatable"
      form-key="svc-work-order-item-status"
      data-list-key="WorkOrderItemStatusDataList"
      :show-select="rights.read"
      :reload="reload"
      data-cy="woItemStatusTable"
      @selection-change="handleSelected"
    >
    </gz-data-table>
  </div>
</template>
<script>
const FORM_KEY = "svc-work-order-item-status";
export default {
  data() {
    return {
      rights: window.$gz.role.defaultRightsObject(),
      selectedItems: [],
      reload: false
    };
  },
  created() {
    this.rights = window.$gz.role.getRights(
      window.$gz.type.WorkOrderItemStatus
    );
    window.$gz.eventBus.$on("menu-click", clickHandler);
    generateMenu(this);
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    handleSelected(selected) {
      this.selectedItems = selected;
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "new":
        m.vm.$router.push({
          name: "svc-work-order-item-status-edit",
          params: { recordid: 0 }
        });
        break;

      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: true,
    icon: "$ayiCircle",
    title: "WorkOrderItemStatusList",
    helpUrl: "svc-work-order-item-status",
    menuItems: [],
    formData: {
      ayaType: window.$gz.type.WorkOrderItemStatus
    }
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$ayiPlus",
      surface: true,
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}
</script>
